<?php

    class Sleep_Action extends Reactor_Action
    {
        protected $tpl = 'sleep.php';
        protected $name = 'Sleep or wait';
		
		public static $registration = array(
			ACTION_NAME => 'Sleep',
			ACTION_CATEGORY => 'Time',
			ACTION_DESCRIPTION => 'Causes a currently running event chain to sleep for X number of seconds.',
			ACTION_AUTHOR => 'Jeremy Yunis, Nagios Enterprises, LLC',
			ACTION_VERSION => '1.0',
			ACTION_DATE => '01/22/2013', //Last version update
			ACTION_AUTHLEVEL => 0,  // 0 - everyone | 1 - Admin only
			ACTION_TYPE => 'core', //core | user. core modules can't be deleted
			ACTION_META => array(),	//Misc information	
		); 		
		
        protected $fields = array(
            'seconds' => array(
                'label' => 'sleep time',
                'validate' => 'trim|required|numeric|min_length[1]|max_length[4]',
            ),
        );

        public function get_label()
        {
            if($params = $this->get_params()) {
                if(array_key_exists('seconds', $params)) {
                    return sprintf('Sleep for %s second(s)', $params['seconds']);
                }
            }
            return parent::get_label();
        }
       
        public function run($context)
        {
            $this->set_context($context);
            $params = $this->get_params();
            if(array_key_exists('seconds', $params)) {
                $this->log('info', 'Going to sleep for '.$params['seconds'].' second(s)...');
                sleep($params['seconds']);
            }
            $this->set_result(0);
            return $context;
        }
    }
